-- I borrowed code from tekkub. I'll give it back some day. 
local _, class = UnitClass("player")
if class ~= "WARLOCK" then return end

if not Broker_SoulShardsDB then
	Broker_SoulShardsDB = {}
	Broker_SoulShardsDB.Del = false
	Broker_SoulShardsDB.Max = 32
end

local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Broker_SoulShards", {type = "data source", icon = "Interface\\Icons\\INV_Misc_Gem_Amethyst_02", text = "0"})
local tipshown = nil
local SSid = 6265 -- SoulShard ID
local CurrentShardAmount = 0
local f = CreateFrame("Frame")
f:Hide()

local DeleteExcess = function(...)
	d=GetItemCount(SSid)-Broker_SoulShardsDB.Max --How many shards to delete
	for Bag=0,4 do
		for Slot=1,GetContainerNumSlots(Bag) do
			if (d>0) then
				link=GetContainerItemLink(Bag,Slot)
				if link and string.find(link, SSid) then
					PickupContainerItem(Bag,Slot)
					DeleteCursorItem()
					d=d-1
				end
			end
		end 
	end
end


local timer
f:SetScript("OnShow", function() timer = 2 end)
f:SetScript("OnEvent", f.Show)
f:RegisterEvent("BAG_UPDATE")
f:SetScript("OnUpdate", function(self, elap)
	timer = timer - elap
	if timer > 0 then return end
 
 	CurrentShardAmount = GetItemCount(SSid)
	if CurrentShardAmount > Broker_SoulShardsDB.Max and Broker_SoulShardsDB.Del == true then
		DeleteExcess()
	end
	CurrentShardAmount = GetItemCount(SSid)
	if CurrentShardAmount < 6 then -- Colour text red
		dataobj.text = "|cffff0000".. CurrentShardAmount.. "|r"
	else
		dataobj.text = CurrentShardAmount
	end

	if tipshown then dataobj.OnEnter(tipshown) end
	self:Hide()
end)



--- Tool Tip ---
function dataobj.OnClick(self, button)
	if IsShiftKeyDown() then --Shift click events
		if button == "LeftButton" and Broker_SoulShardsDB.Max ~= 32 then
			Broker_SoulShardsDB.Max = Broker_SoulShardsDB.Max + 1
		elseif button == "RightButton" and Broker_SoulShardsDB.Max ~= 0 then
			Broker_SoulShardsDB.Max = Broker_SoulShardsDB.Max -1
		end
	else --Any other button
		Broker_SoulShardsDB.Del = not Broker_SoulShardsDB.Del
	end
	
	if tipshown then dataobj.OnEnter(tipshown) end
end

local function GetTipAnchor(frame)
	local x,y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

function dataobj.OnLeave()
	GameTooltip:Hide()
	tipshown = nil
end

function dataobj.OnEnter(self)
	tipshown = self
 	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint(GetTipAnchor(self))
	
	GameTooltip:ClearLines()
	GameTooltip:AddLine("Broker_SoulShards")
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine("|cffeeeeeeShard Limit: |r".. Broker_SoulShardsDB.Max)
	if Broker_SoulShardsDB.Del == true then
		GameTooltip:AddDoubleLine("|cffeeeeeeDeleting shards:|r |cff00ff00True|r")
	else
		GameTooltip:AddDoubleLine("|cffeeeeeeDeleting shards:|r |cffff0000False|r")
	end
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine("|cff69b950Click:|r |cffeeeeeeToggles shard deletion.|r")
	GameTooltip:AddLine("|cff69b950Shift + Left-Click:|r |cffeeeeeeIncrease the amount of shards to keep.|r")
	GameTooltip:AddLine("|cff69b950Shift + Right-Click:|r |cffeeeeeeDecrease the amount of shards to keep.|r")
	GameTooltip:Show()
end
